/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/

// tcpserverDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tcpserver.h"
#include "tcpserverDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define		IDT_SENDDATA	1001
#define		IDT_RECVDATA	1002

#define		IDT_TIMER	1001
#define		SENDERR		0x01
#define		RECVERR		0x02
#define		DISCONN		0x04
#define		ENDTHRD		0x08

//UINT	ThreadPrg(LPVOID pParam);
//
UINT	SendPrg(LPVOID pParam);
UINT	RecvPrg(LPVOID pParam);
UINT	AcceptPrg(LPVOID pParam);
//
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTcpserverDlg dialog

CTcpserverDlg::CTcpserverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTcpserverDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTcpserverDlg)
	m_port = _T("4001");
	m_senddata = _T("");
	m_count = _T("1");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_startflag = FALSE;
	m_errflag = 0;

	m_paravar.butflag = 0;
	char	temp[10];
	wsprintf(temp,"%s",m_count);
	m_paravar.count = atol(temp);
	m_defultdata = "abcdefghij0123456789";
	m_paravar.dataidx = 0;
	m_paravar.flag = 0;	
	m_paravar.sendcnt = 0;
	m_paravar.recvcnt = 0;
	m_paravar.predit = NULL;

}

void CTcpserverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTcpserverDlg)
	DDX_Text(pDX, IDC_PORT, m_port);
	DDV_MaxChars(pDX, m_port, 4);
	DDX_Text(pDX, IDC_SENDDATA, m_senddata);
	DDX_Text(pDX, IDC_COUNT, m_count);
	DDV_MaxChars(pDX, m_count, 2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTcpserverDlg, CDialog)
	//{{AFX_MSG_MAP(CTcpserverDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SENDBUT, OnSendbut)
	//}}AFX_MSG_MAP
	ON_MESSAGE(MX_ACCEPT,OnAccept)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTcpserverDlg message handlers

BOOL CTcpserverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	UpdateButton();
	GetDlgItem(IDOK)->EnableWindow(1);
	GetDlgItem(IDCANCEL)->EnableWindow(0);
	GetDlgItem(IDC_COUNT)->EnableWindow(0);		
	GetDlgItem(IDC_SENDBUT)->EnableWindow(0);		
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTcpserverDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
		if (nID == 61536) {
			m_errflag |= ENDTHRD;
			closesocket(m_sockcli);
			closesocket(m_sockser);
			Sleep(100);
			CDialog::DestroyWindow();
		}
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTcpserverDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTcpserverDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTcpserverDlg::OnOK() 
{
	// TODO: Add extra validation here

//
	m_paravar.flag = 0;
//

	m_startflag = 0;
	m_errflag = 0;
	UpdateData(TRUE);
	if ((m_sockser = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET) {
		CString	err;
        err.Format(IDS_SOCKERR,GetLastError());
        AfxMessageBox(err);		
		m_startflag = 0;
	}
	m_sockinfoser.sin_family = AF_INET;
	m_sockinfoser.sin_addr.S_un.S_addr	= htonl(INADDR_ANY);
	m_sockinfoser.sin_port = htons((unsigned)atol(m_port));

	if ( bind( m_sockser, (struct sockaddr *)&m_sockinfoser, sizeof(m_sockinfoser)) == SOCKET_ERROR ) {
		CString	err;
        err.Format(IDS_BINDERR,GetLastError());
        AfxMessageBox(err);		
		m_startflag = 0;
	}
	listen(m_sockser, 1);
	UpdateButton();

	m_pthread = AfxBeginThread(AcceptPrg, this);

	GetDlgItem(IDOK)->EnableWindow(0);
	GetDlgItem(IDCANCEL)->EnableWindow(1);
	//CDialog::OnOK();
}

void CTcpserverDlg::UpdateButton()
{
//	GetDlgItem(IDOK)->EnableWindow(!m_startflag);
//	GetDlgItem(IDCANCEL)->EnableWindow(m_startflag);
	GetDlgItem(IDC_PORT)->EnableWindow(!m_startflag);
	GetDlgItem(IDC_SENDDATA)->EnableWindow(m_startflag);
}

void CTcpserverDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent == IDT_SENDDATA) {

		if (m_paravar.butflag == 1) {
			if (m_paravar.count == 0) {
				GetDlgItem(IDC_SENDDATA)->EnableWindow(TRUE);
				GetDlgItem(IDC_SENDBUT)->EnableWindow(TRUE);
				GetDlgItem(IDC_COUNT)->EnableWindow(TRUE);
				m_count = "1";
				m_paravar.butflag = 0;
			} else {
				GetDlgItem(IDC_SENDDATA)->EnableWindow(FALSE);
				GetDlgItem(IDC_SENDBUT)->EnableWindow(FALSE);
				GetDlgItem(IDC_COUNT)->EnableWindow(FALSE);
				m_senddata += m_defultdata;
				m_paravar.count--;
			}			
			UpdateData(FALSE);		
		}
		CEdit	*pedit;

		UpdateData(TRUE);				
		m_paravar.data = m_senddata;
		pedit = (CEdit *)GetDlgItem(IDC_SENDDATA);
		pedit->SetSel(32767,32767);
		if (m_paravar.flag & SENDERR) {
			CString	err;
			err.Format(IDS_SENDDATAERR,m_paravar.senderr);
			closesocket(m_sockcli);
			closesocket(m_sockser);
			m_startflag = 0;
			OnCancel();
			AfxMessageBox(err);
		}
	} else if (nIDEvent == IDT_RECVDATA) {
		if (m_paravar.flag & RECVERR) {
			CString	err;
			err.Format(IDS_RECVDATAERR,m_paravar.recverr);
			closesocket(m_sockcli);
			closesocket(m_sockser);
			m_startflag = 0;
			OnCancel();
			AfxMessageBox(err);
		}				
	}
	CDialog::OnTimer(nIDEvent);
}


UINT	SendPrg(LPVOID pParam)
{
	CTcpserverDlg	*pDlg = (CTcpserverDlg *)pParam;

	DWORD	datalen;
	char*	pdata = NULL;
	DWORD	sendlen;
	DWORD	sendret;
	
	while(1) {
		if (pDlg->m_paravar.flag & ENDTHRD)
			break;
		datalen = pDlg->m_paravar.data.GetLength();
		if (datalen < pDlg->m_paravar.dataidx) {
			pDlg->m_paravar.dataidx--;
			continue;
		}
		sendlen = datalen - pDlg->m_paravar.dataidx;
		if (sendlen == 0) {
			Sleep(10);
			continue;	
		}
		pdata = new char [datalen+1];
		strcpy(pdata,pDlg->m_paravar.data.GetBuffer(datalen));		
		pDlg->m_paravar.data.ReleaseBuffer(datalen);
		sendret = 0;
		for(int i = 0 ; (unsigned)i < sendlen ; i++) {
			if ((sendret = send(pDlg->m_sockcli, &pdata[pDlg->m_paravar.dataidx], 1, 0)) == SOCKET_ERROR) {
				pDlg->m_paravar.senderr = GetLastError();
				pDlg->m_paravar.flag |= SENDERR;
				return	TRUE;
			}
			if (sendret > 0) {
				pDlg->m_paravar.sendcnt += sendret;
				pDlg->m_paravar.dataidx++;
			} else if (sendret == 0)
				i--;
		}
		pDlg->m_paravar.dataidx = datalen;	
		delete [] pdata;
	}
	return	TRUE;
}

UINT	RecvPrg(LPVOID pParam)
{
	CTcpserverDlg	*pDlg = (CTcpserverDlg *)pParam;

	char	recvdata[256];
	int		recvret;
	
	while(1) {
		if (pDlg->m_paravar.flag & ENDTHRD)
			break;
		if ((recvret = recv(pDlg->m_sockcli, recvdata, 256, 0)) == SOCKET_ERROR) {
			if ((pDlg->m_paravar.recverr = GetLastError())!=WSAEWOULDBLOCK) {			
				pDlg->m_paravar.flag |= RECVERR;
				return	TRUE;
			}
		}
		if (recvret > 0) {			
			if (recvret == 1) {
				if (recvdata[0] == NULL)
					continue;
				else {
					recvdata[1] = NULL;
					pDlg->m_paravar.recvcnt += recvret;
				}
			} else {
				if (recvdata[recvret-1] != NULL) {
					recvdata[recvret] = NULL;
					pDlg->m_paravar.recvcnt += recvret;
				} else {
					pDlg->m_paravar.recvcnt += (recvret-1);
				}
			}
			if (pDlg->m_paravar.recvcnt < 27000) {
				pDlg->m_paravar.predit->SetSel(32767,32767);
				pDlg->m_paravar.predit->ReplaceSel(recvdata);
			} 
		} if (recvret == 0)	{
			AfxMessageBox("The connection has been interrupted !");
			break;
		}
	}	

	pDlg->m_startflag = 0;
	pDlg->m_senddata = "";
	pDlg->m_paravar.data = pDlg->m_senddata;
	pDlg->m_paravar.dataidx = 0;
	pDlg->m_paravar.flag = 0;	
	pDlg->m_paravar.sendcnt = 0;

	
	if(pDlg->m_paravar.recvcnt != 0) {
		pDlg->m_paravar.recvcnt = 0;
		pDlg->m_paravar.predit->SetSel(0,-1);
		pDlg->m_paravar.predit->ReplaceSel("");		
	}
	pDlg->m_paravar.predit = NULL;	
	pDlg->m_paravar.flag |= ENDTHRD;
	pDlg->KillTimer(IDT_SENDDATA);
	pDlg->KillTimer(IDT_RECVDATA);
	pDlg->m_paravar.butflag = 0;
	pDlg->m_count = "1";
	closesocket(pDlg->m_sockcli);
	closesocket(pDlg->m_sockser);
	pDlg->UpdateData(FALSE);
	pDlg->UpdateButton();

	pDlg->GetDlgItem(IDOK)->EnableWindow(1);
	pDlg->GetDlgItem(IDCANCEL)->EnableWindow(0);
	pDlg->GetDlgItem(IDC_COUNT)->EnableWindow(0);		
	pDlg->GetDlgItem(IDC_SENDBUT)->EnableWindow(0);		
	TerminateThread(pDlg->m_psendthread->m_hThread,0);
	TerminateThread(pDlg->m_precvthread->m_hThread,0);
	TerminateThread(pDlg->m_pthread->m_hThread,0);
	return	TRUE;
}


void CTcpserverDlg::OnCancel() 
{
	// TODO: Add extra cleanup here

	m_startflag = 0;
	m_senddata = "";
	m_paravar.data = m_senddata;
	m_paravar.dataidx = 0;
	m_paravar.flag = 0;	
	m_paravar.sendcnt = 0;
	TerminateThread(m_psendthread->m_hThread,0);
	TerminateThread(m_precvthread->m_hThread,0);
	TerminateThread(m_pthread->m_hThread,0);
	
	if(m_paravar.recvcnt != 0) {
		m_paravar.recvcnt = 0;
		m_paravar.predit->SetSel(0,-1);
		m_paravar.predit->ReplaceSel("");		
	}
	m_paravar.predit = NULL;	
	m_paravar.flag |= ENDTHRD;
	KillTimer(IDT_SENDDATA);
	KillTimer(IDT_RECVDATA);
	m_paravar.butflag = 0;
	m_count = "1";
	closesocket(m_sockcli);
	closesocket(m_sockser);
	UpdateData(FALSE);
	UpdateButton();

	GetDlgItem(IDOK)->EnableWindow(1);
	GetDlgItem(IDCANCEL)->EnableWindow(0);
	GetDlgItem(IDC_COUNT)->EnableWindow(0);		
	GetDlgItem(IDC_SENDBUT)->EnableWindow(0);		
	//CDialog::OnCancel();
}

UINT	AcceptPrg(LPVOID pParam)
{
	CTcpserverDlg	*pDlg = (CTcpserverDlg *)pParam;
	int	addrsize;

	addrsize = sizeof(pDlg->m_sockinfocli);
	if ((pDlg->m_sockcli = accept(pDlg->m_sockser, (struct sockaddr *)&pDlg->m_sockinfocli, &addrsize)) == INVALID_SOCKET) {
		CString	err;
		err.Format(IDS_ACCEPTERR,GetLastError());
		AfxMessageBox(err);		
		pDlg->m_startflag = 0;
	} else 
		pDlg->m_startflag = 1;

	if (pDlg->m_startflag != 0)
		pDlg->SendMessage(MX_ACCEPT,0,0);

	return TRUE;
}

LRESULT	CTcpserverDlg::OnAccept(WPARAM wp,LPARAM lp)
{
	UNREFERENCED_PARAMETER(wp);
	UNREFERENCED_PARAMETER(lp);

	if (m_startflag != 0) {
		GetDlgItem(IDC_SENDDATA)->EnableWindow(m_startflag);
	    GetDlgItem(IDC_COUNT)->EnableWindow(m_startflag);		
	    GetDlgItem(IDC_SENDBUT)->EnableWindow(m_startflag);		
		SetTimer(IDT_SENDDATA, 50, NULL);
		SetTimer(IDT_RECVDATA, 50, NULL);
		m_paravar.predit = (CEdit *)GetDlgItem(IDC_RECVDATA);
		m_psendthread = AfxBeginThread(SendPrg, this);
		m_precvthread = AfxBeginThread(RecvPrg, this);
	}
	return TRUE;
}

void CTcpserverDlg::OnSendbut() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_paravar.butflag = 1;
	char	temp[10];
	wsprintf(temp,"%s",m_count);
	m_paravar.count = atol(temp);		
}
