
/* Copyright (C) MOXA Inc. All rights reserved.

   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING-GPL for details.

   moxacan_ioctl.h

   History:
   Date		Author			Comment
   01-17-2008	Victor Yu.		Create it.
*/
#ifndef _MOXACAN_IOCTL_H
#define _MOXACAN_IOCTL_H

#ifndef BIT
#define BIT(x)	(1<<(x))
#endif	// BIT

#define MAX_CAN_DATA_LENGTH	8

typedef union __attribute__ ((packed)) can_data_union {
	unsigned char	array[MAX_CAN_DATA_LENGTH];
	struct byte_struct {
		unsigned char	byte1;
		unsigned char	byte2;
		unsigned char	byte3;
		unsigned char	byte4;
		unsigned char	byte5;
		unsigned char	byte6;
		unsigned char	byte7;
		unsigned char	byte8;
	} byte;
} can_data_u;

typedef struct user_frame_struct {
	int		id;
	int		info;	// RTR & extend ID flag
#define USER_RTR	BIT(0)
#define USER_EXTEND_ID	BIT(1)
	int		data_length;
	can_data_u	data;
} user_frame_t;

// ioctl command code
#define MOXACAN_IOCTL_SET_BAUD_RATE	0x100
#define MOXACAN_IOCTL_GET_BAUD_RATE	0x101

#endif	// _MOXACAN_IOCTL_H
